#ifndef _HARK__BEAMFORMING__MSNR_H__INCLUDED_
#define _HARK__BEAMFORMING__MSNR_H__INCLUDED_ 1

#include "BF.h"

namespace BF
{
    class MSNR : public BF
    {
    public:
	MSNR(int numFreq, int samplingRate, double soundSpeed, double alpha);
	virtual ~MSNR();

    public:
	virtual BfType getBfAlgorithmType() const { return BfMSNR; }

	virtual void updateSources(const std::vector<MicLocation> &micPositions, const std::vector<SourceLocation> &sourcePositions);
	virtual void adaptSeparationMatrices();

    private:
	std::vector<Matrix> Rss; /* sizs_is(numSrc * numFreq), element_is(Matrix(numMic, numMic)) */
	std::vector<Matrix> Rnn; /* sizs_is(numSrc * numFreq), element_is(Matrix(numMic, numMic)) */
	double alpha;

    };
}

#endif
